// Generated from seccomp.json. Do not edit!
#ifndef DOCKER_SECCOMP_SCHEMA_H
#define DOCKER_SECCOMP_SCHEMA_H

#include <sys/types.h>
#include <stdint.h>
#include "json_common.h"
#include "defs.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef struct {
    char *architecture;
    char **sub_architectures;
    size_t sub_architectures_len;

}
docker_seccomp_arch_map_element;

void free_docker_seccomp_arch_map_element (docker_seccomp_arch_map_element *ptr);

docker_seccomp_arch_map_element *make_docker_seccomp_arch_map_element (yajl_val tree, const struct parser_context *ctx, parser_error *err);

typedef struct {
    uint32_t index;
    uint64_t value;
    uint64_t value_two;
    char *op;
}
docker_seccomp_syscalls_args_element;

void free_docker_seccomp_syscalls_args_element (docker_seccomp_syscalls_args_element *ptr);

docker_seccomp_syscalls_args_element *make_docker_seccomp_syscalls_args_element (yajl_val tree, const struct parser_context *ctx, parser_error *err);

typedef struct {
    char **arches;
    size_t arches_len;

    char **caps;
    size_t caps_len;

    yajl_val _residual;
}
docker_seccomp_syscalls_includes;

void free_docker_seccomp_syscalls_includes (docker_seccomp_syscalls_includes *ptr);

docker_seccomp_syscalls_includes *make_docker_seccomp_syscalls_includes (yajl_val tree, const struct parser_context *ctx, parser_error *err);

yajl_gen_status gen_docker_seccomp_syscalls_includes (yajl_gen g, const docker_seccomp_syscalls_includes *ptr, const struct parser_context *ctx, parser_error *err);

typedef struct {
    char **arches;
    size_t arches_len;

    char **caps;
    size_t caps_len;

    yajl_val _residual;
}
docker_seccomp_syscalls_excludes;

void free_docker_seccomp_syscalls_excludes (docker_seccomp_syscalls_excludes *ptr);

docker_seccomp_syscalls_excludes *make_docker_seccomp_syscalls_excludes (yajl_val tree, const struct parser_context *ctx, parser_error *err);

yajl_gen_status gen_docker_seccomp_syscalls_excludes (yajl_gen g, const docker_seccomp_syscalls_excludes *ptr, const struct parser_context *ctx, parser_error *err);

typedef struct {
    char **names;
    size_t names_len;

    char *action;
    docker_seccomp_syscalls_args_element **args;
    size_t args_len;

    char *comment;
    docker_seccomp_syscalls_includes *includes;
    docker_seccomp_syscalls_excludes *excludes;
}
docker_seccomp_syscalls_element;

void free_docker_seccomp_syscalls_element (docker_seccomp_syscalls_element *ptr);

docker_seccomp_syscalls_element *make_docker_seccomp_syscalls_element (yajl_val tree, const struct parser_context *ctx, parser_error *err);

typedef struct {
    char *default_action;

    docker_seccomp_arch_map_element **arch_map;
    size_t arch_map_len;

    docker_seccomp_syscalls_element **syscalls;
    size_t syscalls_len;

    yajl_val _residual;
}
docker_seccomp;

void free_docker_seccomp (docker_seccomp *ptr);

docker_seccomp *make_docker_seccomp (yajl_val tree, const struct parser_context *ctx, parser_error *err);

yajl_gen_status gen_docker_seccomp (yajl_gen g, const docker_seccomp *ptr, const struct parser_context *ctx, parser_error *err);

docker_seccomp *docker_seccomp_parse_file(const char *filename, const struct parser_context *ctx, parser_error *err);

docker_seccomp *docker_seccomp_parse_file_stream(FILE *stream, const struct parser_context *ctx, parser_error *err);

docker_seccomp *docker_seccomp_parse_data(const char *jsondata, const struct parser_context *ctx, parser_error *err);

char *docker_seccomp_generate_json(const docker_seccomp *ptr, const struct parser_context *ctx, parser_error *err);

#ifdef __cplusplus
}
#endif

#endif

